dependencies:
  - role: gitlab_prereq
  - role: ruby
    tags: ruby
  - role: node
  - role: yarn

  - role: systemd_service
    systemd_service: gitlab-unicorn
    systemd_service_options:
      CPUAffinity: >-
        0-{{ ansible_processor_vcpus // 2 - 1 }}
      ExecStart: >-
        {{ ruby_bundle }} exec unicorn_rails -c {{ ansible_user_dir }}/gitlab/config/unicorn.rb -E production -D
      Type: forking
      WorkingDirectory: "{{ ansible_user_dir }}/gitlab"
      ExecStop: /bin/kill -QUIT $MAINPID
      ExecReload: /bin/kill -USR2 $MAINPID
      RuntimeDirectory: gitlab-unicorn
      RuntimeDirectoryMode: "0700"
      Environment: prometheus_multiproc_dir=%t/gitlab-unicorn
      PIDFile: "%t/gitlab-unicorn/pid"

  - role: systemd_service
    systemd_service: gitlab-sidekiq
    systemd_service_options:
      CPUSchedulingPolicy: batch
      ExecStart: >-
        {{ ruby_bundle }} exec sidekiq -C config/sidekiq_queues.yml -c 5 -e production
      WorkingDirectory: "{{ ansible_user_dir }}/gitlab"

  - role: systemd_service
    systemd_service: gitlab-mailroom
    systemd_service_options:
      CPUSchedulingPolicy: batch
      ExecStart: >-
        {{ ruby_bundle }} exec mail_room -q -c config/mail_room.yml
      WorkingDirectory: "{{ ansible_user_dir }}/gitlab"
      Environment: RAILS_ENV=production

  - role: logrotate_entry
    logrotate_entry: gitlab
    logrotate_entry_files: "{{ ansible_user_dir }}/gitlab/log/*.log"
    logrotate_entry_postrotate:
      - /bin/systemctl --user reload gitlab-unicorn
